<template>
  <b-col class="ps-0">
    <!-- Side Bar Container Card -->
    <b-card id="sidebarContainer">
      <!-- Side Bar Button List -->
      <b-list-group v-if="!isLoading && resultTypes && resultTypes.length > 0">
        <!-- Side Bar Content -->
        <b-list-group-item
          v-for="category in resultTypes"
          :key="category.Name"
          button
          :active="category.Name === selectedFilter"
          :disabled="category.Count === 0"
          hover
          @click="assignResultsFilter(category)"
        >
          <b-row align-v="center" no-gutters>
            <b-col>
              <!-- Search Result Type Label -->
              <span>
                {{ $t(`page.search.${category.Name.toLowerCase()}`) }}
              </span>
            </b-col>
            <b-col md="auto">
              <!-- Total Count Badge -->
              <b-badge
                class="float-end"
                :variant="
                  category.Name === selectedFilter
                    ? 'light'
                    : category.Count > 0
                      ? 'secondary'
                      : 'light'
                "
              >
                {{ category.Count }}
              </b-badge>
            </b-col>
          </b-row>
        </b-list-group-item>
      </b-list-group>

      <!-- Side Bar Skeleton -->
      <b-list-group v-else>
        <b-list-group-item v-for="key in 4" :key="key">
          <b-placeholder animation="wave" width="85%" />
        </b-list-group-item>
      </b-list-group>
    </b-card>
  </b-col>
</template>

<script lang="ts" setup>
// import the store for current module
import useSearchStore from "../../store";
import type { Category } from "../../types";
import type { SearchCategoryType } from "@coscine/api-client/dist/types/Coscine.Api";

const route = useRoute();

const selectedFilter = defineModel<string>({ required: true });

defineProps({
  isLoading: {
    default: true,
    type: Boolean,
  },
});

const searchStore = useSearchStore();

const resultTypes = computed(() => {
  if (searchStore.categories) {
    return searchStore.categories;
  } else {
    return null;
  }
});

const assignResultsFilter = (category: Category) => {
  let resultsFilter = selectedFilter.value.toString();
  resultsFilter = category.Name;
  selectedFilter.value = resultsFilter;
};

selectedFilter.value =
  (route.query["filter"] as SearchCategoryType) ?? selectedFilter.value;
</script>

<style scoped>
.card-body {
  padding: 0rem;
}
</style>
